module LegalMoves where

import Data.Graph.Inductive
import List
import Maybe
import State

legalMoves :: WorldSkeleton -> PlayerState -> [PlayerState]
legalMoves ws ps =
    let m = ws_map_ps ws
    in  [fromJust (lab m n) | n <- (suc m ((ws_ps_to_node ws) ps))]

legalMovesSameState :: WorldSkeleton -> PlayerState -> [PlayerState]
legalMovesSameState ws ps@(PlayerState { ps_type = pt }) =
    [move | move <- legalMoves ws ps, ps_type move == pt]

