module RobberAimless where

import Control.Concurrent.MVar

import ConcurrentUtil
import State
import AI
import LegalMoves
import RandomUtils

-- robber-aimless makes random legal moves

robber_aimless = RobberAI { rai_name = "robber-aimless",
                             rai_init = robber_aimless_init,
                             rai_move = robber_aimless_move }

data AimlessState = AimlessState {
    cs_skeleton :: WorldSkeleton,
    cs_current_ps :: PlayerState
}

robber_aimless_init :: InitAI AimlessState
robber_aimless_init skel state_var =
    putMVar state_var
        (AimlessState { cs_skeleton = skel,
                         cs_current_ps = PlayerState {
                                             ps_type = PT_robber,
                                             ps_loc = ws_robber_start skel }})

robber_aimless_move :: StepAI AimlessState WorldUpdate PlayerState
robber_aimless_move state update result_var =
    do -- seed with identity move in case time runs out
       putMVarF2 result_var (state, cs_current_ps state)
       let legal_states = legalMoves (cs_skeleton state) (cs_current_ps state)
       next_ps <- random_list_elt legal_states
       let next_state = state { cs_current_ps = next_ps }
       swapMVarF2_ result_var (next_state, next_ps)

