module RobberStatue where

import Control.Concurrent.MVar

import State
import AI

-- robber-statue never moves from its original location

robber_statue = RobberAI { rai_name = "robber-statue",
                           rai_init = robber_statue_init,
                           rai_move = robber_statue_move }

robber_statue_init :: InitAI PlayerState
robber_statue_init skl state_var =
    putMVar state_var (PlayerState { ps_type = PT_robber,
                                     ps_loc = ws_robber_start skl })

robber_statue_move :: StepAI PlayerState WorldUpdate PlayerState
robber_statue_move state world_update result_var =
    putMVar result_var (state, state)

