module Main where

import System

import State
import Protocol
import AI
import CopStatue
import CopAimless
import CopSearch
import CopAlarmed
import CopBanker

main :: IO ()
main =
    do args <- getArgs
       case args of
         [] -> run_cop cop_banker
         ["statue"] -> run_cop cop_statue
         ["aimless"] -> run_cop cop_aimless
         ["alarmed"] -> run_cop cop_alarmed
         ["search"] -> run_cop cop_search
         ["banker"] -> run_cop cop_banker
         ["-h"] -> usage
         ["--help"] -> usage
         _ -> do putStrLn ("ERROR: bad arguments: " ++ unlines args)
                 usage

usage :: IO ()
usage =
    do putStrLn "usage: cop [cop-name]"
       putStrLn "  available cops: statue aimless alarmed search banker"
       exitWith (ExitFailure 1)

