module Main where

import LegalMoves
import Protocol
import Parser
import State
import RobberTracking
import RobberTrackingImpl
import SearchState
import SearchMove
import Evaluate
import Minimax

main :: IO ()
main =
    do putStrLn "Hello, world!"
       ws <- parse_from_stdin p_world_skeleton (== "wsk/")
       let --loc = "47-and-lake-shore" -- ws_hq ws -- ws_robber_start ws
           --playerType = PT_cop_car -- PT_robber
           --ps = PlayerState {ps_loc = loc,
           --                  ps_type = playerType}
           --newStates = legalMoves ws ps
           copState = PlayerState { ps_loc = ws_hq ws, --"54-and-kenwood",
                                    ps_type = PT_cop_foot }
           copState' = PlayerState { ps_loc = "55-and-kimbark",
                                    ps_type = PT_cop_foot }
           robberState = PlayerState { ps_loc = "rochdale-and-dorchester",
                                           --ws_robber_start ws,
                                           --"54-and-ridgewood",
                                       ps_type = PT_robber }
           ss = SearchState { ss_epoch = 0,
                              ss_cop_states = (replicate 5 copState),
                              ss_robber_state = robberState,
                              ss_fake_robber_states = Nothing,
                              ss_impossible_list =
                                  initImpossibleList ws }
           ss1 = ss { ss_epoch = 1 }
           robberLegalMoves = ssLegalMoves ws ss
           robberNextStates = map (ssAdvance ws ss) robberLegalMoves
           robberScores = map (evaluateGameOver ws) robberNextStates
           copInitialMoves = ssInitialMoves ws ss1 --ssLegalMoves ws ss1
           copRefinedMoves = concatMap (ssRefineMoves ws ss1) copInitialMoves
           copRefinedMoves' = concatMap (ssRefineMoves ws ss1)
                                        [last copRefinedMoves]
           copNextStates = map (ssAdvance ws ss1) copRefinedMoves'
           copNextStates' =
               map (\ssFoo -> ssFoo { ss_epoch = 3 })
                   copNextStates
           copScores = map (evaluate ws) copNextStates'

       putStrLn $ unlines $ map show copInitialMoves
       putStrLn "---"
       putStrLn $ unlines $ map show copRefinedMoves
       putStrLn "---"
       putStrLn $ unlines $ map show copRefinedMoves'
       --putStrLn "---"
       --putStrLn $ unlines $ map show copNextStates
       --putStrLn "---"
       --putStrLn $ unlines $ map show copNextStates'
       putStrLn "---"
       putStrLn $ unlines $ map show copScores

       --putStrLn $ unlines $ map show robberLegalMoves
       --putStrLn "---"
       --putStrLn $ unlines $ map show robberNextStates
       --putStrLn "---"
       --putStrLn $ unlines $ map show robberScores

       --putStrLn $ show $ minimax 3 False ws ss
       putStrLn $ show $ minimax 2 True ws ss1
       --putStrLn $ unlines $ map show (ssLegalMoves ws ss1)
       --putStrLn "---"
       --putStrLn $ unlines $ map show newStates
