module Main where

import System
import List

import State
import Protocol
import AI
import RobberStatue
import RobberAimless
import RobberSearch
import RobberFearless
import RobberHeuristic
import RobberJanosik

main :: IO ()
main =
    do args <- getArgs
       case args of
         [] -> run_robber robber_heuristic
         ["statue"] -> run_robber robber_statue
         ["aimless"] -> run_robber robber_aimless
         ["search"] -> run_robber robber_search
         ["fearless"] -> run_robber robber_fearless
         ["heuristic"] -> run_robber robber_heuristic
         ["janosik"] -> run_robber robber_janosik
         ["-h"] -> usage
         ["--help"] -> usage
         _ -> do putStrLn ("ERROR: bad arguments: " ++ unlines args)
                 usage

usage :: IO ()
usage =
    do putStrLn "usage: robber [robber-name]"
       putStrLn "  available robbers: statue aimless search fearless heuristic janosik"
       exitWith (ExitFailure 1)

